---
title: Get blueprint
slug: cms-13/api/get-blueprint
docTags: 
createdAt: 2026-08-28T15:24:16.532Z
---

{
  "id": "RgTAdyLeO5gbLJpDGvgtr",
  "type": "api-oas-v2",
  "data": {
    "method": "GET",
    "url": "/_cms/v1/blueprints/{key}",
    "servers": [
      {
        "url": "/_cms/v1/blueprints/{key}",
        "description": "Optimizely CMS API"
      }
    ],
    "name": "Get blueprint",
    "description": "Get the blueprint with the provided key.",
    "contentType": "application/json",
    "request": {
      "pathParameters": [
        {
          "kind": "required",
          "name": "key",
          "type": "string",
          "description": "The key of the blueprint to retrieve."
        }
      ],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        },
        {
          "kind": "optional",
          "name": "If-None-Match",
          "type": "string",
          "description": "If provided and the value matches the RFC7232 ETag of the current resource a 304 NotModified response will be returned. Weak ETags will always be ignored."
        },
        {
          "kind": "optional",
          "name": "If-Modified-Since",
          "type": "string<http-date>",
          "description": "<p>If provided and the resource has not been modified since the date a 304 NotModified response will be returned. This parameter will be ignored if an 'If-None-Match' parameter is also provided.</p>",
          "format": "http-date"
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "apiAuth",
          "name": "apiAuth",
          "kind": "optional",
          "type": "oauth2",
          "description": "Use this scheme to generate an access token that can be used to access the API.",
          "oauth2Flows": {
            "clientCredentials": {
              "tokenUrl": "/_cms/v1/oauth/token",
              "scopes": {
                "api:admin": "Grants full administrative access to the API"
              }
            }
          },
          "requiredScopes": [
            "api:admin"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "OK",
        "jsonExample": "",
        "isExpanded": true,
        "headers": [
          {
            "kind": "optional",
            "name": "ETag",
            "type": "string",
            "description": "<p>The RFC7232 ETag header field in a response provides the current entity-tag for the resource. An entity-tag is an opaque identifier for different versions of a resource over time, regardless whether multiple versions are valid at the same time.</p>"
          },
          {
            "kind": "optional",
            "name": "Last-Modified",
            "type": "string<http-date>",
            "description": "The date and time at which the resource was last modified.",
            "format": "http-date"
          }
        ],
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "Represents a blueprint of a content item.",
            "customType": "Blueprint",
            "schema": [
              {
                "name": "key",
                "kind": "optional",
                "type": "string",
                "description": "<p>The unique identifier (key) of the resource.</p>"
              },
              {
                "name": "displayName",
                "kind": "required",
                "type": "string",
                "description": "The display name of this blueprint.",
                "minLength": 1,
                "maxLength": 255
              },
              {
                "name": "contentType",
                "kind": "required",
                "type": "string",
                "description": "The content type of this blueprint.",
                "minLength": 1
              },
              {
                "name": "created",
                "kind": "optional",
                "type": "string<date-time>",
                "readOnly": true,
                "description": "A timestamp indicating when this resource was first created.",
                "format": "date-time"
              },
              {
                "name": "createdBy",
                "kind": "optional",
                "type": "string",
                "readOnly": true,
                "description": "The name of the user or application that created this resource."
              },
              {
                "name": "lastModified",
                "kind": "optional",
                "type": "string<date-time>",
                "readOnly": true,
                "description": "Indicates the last time this resource was modified.",
                "format": "date-time"
              },
              {
                "name": "lastModifiedBy",
                "kind": "optional",
                "type": "string",
                "readOnly": true,
                "description": "The name of the user or application that last modified this resource."
              },
              {
                "name": "content",
                "kind": "required",
                "type": "object",
                "description": "Represents the data part of a Blueprint.",
                "modelRef": "#/components/schemas/BlueprintData",
                "customType": "BlueprintData",
                "schema": [],
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "ContentData",
                    "description": "",
                    "modelRef": "#/components/schemas/ContentData",
                    "schema": [
                      {
                        "name": "binding",
                        "kind": "optional",
                        "type": "object",
                        "description": "<p>Associates a content item with another source content item, establishing a relationship defined by a content type binding. Used for linking managed content to external or reference content.</p>",
                        "modelRef": "#/components/schemas/ContentBinding",
                        "customType": "ContentBinding",
                        "schema": [
                          {
                            "name": "contentTypeBinding",
                            "kind": "optional",
                            "type": "string",
                            "description": "The binding definition key that controls how the source content item is linked and accessed."
                          },
                          {
                            "name": "source",
                            "kind": "required",
                            "type": "string<uri>",
                            "description": "The reference to the source content item that is being bound. This cannot be empty.",
                            "format": "uri"
                          }
                        ]
                      },
                      {
                        "name": "properties",
                        "kind": "optional",
                        "type": "map",
                        "description": "Properties as they are defined by corresponding component or content type.",
                        "example": "",
                        "customType": "map<string, PropertyData>",
                        "schema": []
                      }
                    ]
                  },
                  {
                    "name": "object",
                    "description": "",
                    "schema": [
                      {
                        "name": "composition",
                        "kind": "optional",
                        "type": "object",
                        "description": "Specifies a node in a content composition.",
                        "modelRef": "#/components/schemas/CompositionNode",
                        "customType": "CompositionNode",
                        "schema": [
                          {
                            "name": "id",
                            "kind": "optional",
                            "type": "string",
                            "description": "Specifies an identifier of this CompositionNode."
                          },
                          {
                            "name": "displayName",
                            "kind": "optional",
                            "type": "string",
                            "description": "The display name of this ContentType.",
                            "maxLength": 255
                          },
                          {
                            "name": "nodeType",
                            "kind": "required",
                            "type": "string",
                            "description": "The node type of this CompositionNode.",
                            "minLength": 1
                          },
                          {
                            "name": "layoutType",
                            "kind": "optional",
                            "type": "string",
                            "description": "The node layout type of this CompositionNode"
                          },
                          {
                            "name": "displaySettings",
                            "kind": "optional",
                            "type": "object",
                            "description": "Defines display settings for a CompositionNode.",
                            "modelRef": "#/components/schemas/CompositionDisplaySettings",
                            "customType": "CompositionDisplaySettings",
                            "schema": [
                              {
                                "name": "displayTemplate",
                                "kind": "required",
                                "type": "string",
                                "description": "The display template that these settings apply to.",
                                "minLength": 1
                              },
                              {
                                "name": "settings",
                                "kind": "optional",
                                "type": "map",
                                "nullable": true,
                                "description": "The display settings of this CompositionNode.",
                                "example": "",
                                "customType": "map<string, string>",
                                "schema": []
                              }
                            ]
                          },
                          {
                            "name": "component",
                            "kind": "optional",
                            "type": "object",
                            "description": "Represents a content component.",
                            "modelRef": "#/components/schemas/ContentComponent",
                            "customType": "ContentComponent",
                            "schema": [],
                            "complexType": "allOf",
                            "complexItems": [
                              {
                                "name": "ContentData",
                                "description": "",
                                "modelRef": "#/components/schemas/ContentData",
                                "schema": [
                                  {
                                    "name": "",
                                    "description": "",
                                    "customType": "Circular-Reference"
                                  }
                                ]
                              },
                              {
                                "name": "object",
                                "description": "",
                                "schema": [
                                  {
                                    "name": "reference",
                                    "kind": "optional",
                                    "type": "string<uri>",
                                    "nullable": true,
                                    "description": "A reference to the content of this component. Cannot be assigned together with 'contentType' or 'properties'.",
                                    "format": "uri"
                                  },
                                  {
                                    "name": "contentType",
                                    "kind": "optional",
                                    "type": "string",
                                    "description": "The key of the content type that this is an embedded instance of."
                                  }
                                ]
                              }
                            ]
                          },
                          {
                            "name": "nodes",
                            "kind": "optional",
                            "type": "array",
                            "nullable": true,
                            "description": "The child nodes for this CompositionNode.",
                            "modelRef": "#/components/schemas/CompositionNode",
                            "customType": "CompositionNode[]",
                            "schema": [
                              {
                                "name": "",
                                "description": "",
                                "customType": "Circular-Reference"
                              }
                            ]
                          }
                        ]
                      }
                    ]
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/Blueprint",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "304",
        "description": "Not Modified",
        "jsonExample": "",
        "isExpanded": true,
        "headers": [
          {
            "kind": "optional",
            "name": "ETag",
            "type": "string",
            "description": "<p>The RFC7232 ETag header field in a response provides the current entity-tag for the resource. An entity-tag is an opaque identifier for different versions of a resource over time, regardless whether multiple versions are valid at the same time.</p>"
          },
          {
            "kind": "optional",
            "name": "Last-Modified",
            "type": "string<http-date>",
            "description": "The date and time at which the resource was last modified.",
            "format": "http-date"
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Unauthorized",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "403",
        "description": "Forbidden",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "404",
        "description": "Not Found",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "500",
        "description": "Internal Server Error",
        "jsonExample": "",
        "isExpanded": true
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "yJWAnsuKorpiOwC-uONbM",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request GET \\\n     --url /_cms/v1/blueprints/{key} \\\n     --header 'accept: application/json'"
        },
        {
          "id": "zINwDAhhbAa6LvwDdy3UN",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'GET',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"/_cms/v1/blueprints/{key}\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "Ug_y4FKMOKV_SL3_k2JEg",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"/_cms/v1/blueprints/{key}\")\n\nhttp = Net::HTTP.new(url.host, url.port);\nrequest = Net::HTTP::Get.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = http.request(request)\nputs response.read_body\n"
        },
        {
          "id": "cq7QaMx-IDfrBclLSTImK",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"/_cms/v1/blueprints/{key}\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"GET\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "yJWAnsuKorpiOwC-uONbM"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// OK\n{\n  \"key\": \"\",\n  \"displayName\": \"\",\n  \"contentType\": \"\",\n  \"created\": \"\",\n  \"createdBy\": \"\",\n  \"lastModified\": \"\",\n  \"lastModifiedBy\": \"\",\n  \"content\": {}\n}"
        },
        {
          "id": "response-1-304",
          "language": "304",
          "code": "// Not Modified\n"
        },
        {
          "id": "response-2-401",
          "language": "401",
          "code": "// Unauthorized\n"
        },
        {
          "id": "response-3-403",
          "language": "403",
          "code": "// Forbidden\n"
        },
        {
          "id": "response-4-404",
          "language": "404",
          "code": "// Not Found\n"
        },
        {
          "id": "response-5-500",
          "language": "500",
          "code": "// Internal Server Error\n"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}